Merge branch 'ph/maint-submodule-status-fix'
[git/git.git] / t / test-lib-functions.sh
CommitLineData
12a29b1a
TR
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
17
18# The semantics of the editor variables are that of invoking
19# sh -c "$EDITOR \"$@\"" files ...
20#
21# If our trash directory contains shell metacharacters, they will be
22# interpreted if we just set $EDITOR directly, so do a little dance with
23# environment variables to work around this.
24#
25# In particular, quoting isn't enough, as the path may contain the same quote
26# that we're using.
27test_set_editor () {
28 FAKE_EDITOR="$1"
29 export FAKE_EDITOR
30 EDITOR='"$FAKE_EDITOR"'
31 export EDITOR
32}
33
34test_decode_color () {
35 awk '
36 function name(n) {
37 if (n == 0) return "RESET";
38 if (n == 1) return "BOLD";
39 if (n == 30) return "BLACK";
40 if (n == 31) return "RED";
41 if (n == 32) return "GREEN";
42 if (n == 33) return "YELLOW";
43 if (n == 34) return "BLUE";
44 if (n == 35) return "MAGENTA";
45 if (n == 36) return "CYAN";
46 if (n == 37) return "WHITE";
47 if (n == 40) return "BLACK";
48 if (n == 41) return "BRED";
49 if (n == 42) return "BGREEN";
50 if (n == 43) return "BYELLOW";
51 if (n == 44) return "BBLUE";
52 if (n == 45) return "BMAGENTA";
53 if (n == 46) return "BCYAN";
54 if (n == 47) return "BWHITE";
55 }
56 {
57 while (match($0, /\033\[[0-9;]*m/) != 0) {
58 printf "%s<", substr($0, 1, RSTART-1);
59 codes = substr($0, RSTART+2, RLENGTH-3);
60 if (length(codes) == 0)
61 printf "%s", name(0)
62 else {
63 n = split(codes, ary, ";");
64 sep = "";
65 for (i = 1; i <= n; i++) {
66 printf "%s%s", sep, name(ary[i]);
67 sep = ";"
68 }
69 }
70 printf ">";
71 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
72 }
73 print
74 }
75 '
76}
77
78nul_to_q () {
7096b648 79 "$PERL_PATH" -pe 'y/\000/Q/'
12a29b1a
TR
80}
81
82q_to_nul () {
7096b648 83 "$PERL_PATH" -pe 'y/Q/\000/'
12a29b1a
TR
84}
85
86q_to_cr () {
87 tr Q '\015'
88}
89
90q_to_tab () {
91 tr Q '\011'
92}
93
94append_cr () {
95 sed -e 's/$/Q/' | tr Q '\015'
96}
97
98remove_cr () {
99 tr '\015' Q | sed -e 's/Q$//'
100}
101
102# In some bourne shell implementations, the "unset" builtin returns
103# nonzero status when a variable to be unset was not set in the first
104# place.
105#
106# Use sane_unset when that should not be considered an error.
107
108sane_unset () {
109 unset "$@"
110 return 0
111}
112
113test_tick () {
114 if test -z "${test_tick+set}"
115 then
116 test_tick=1112911993
117 else
118 test_tick=$(($test_tick + 60))
119 fi
120 GIT_COMMITTER_DATE="$test_tick -0700"
121 GIT_AUTHOR_DATE="$test_tick -0700"
122 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
123}
124
125# Stop execution and start a shell. This is useful for debugging tests and
126# only makes sense together with "-v".
127#
128# Be sure to remove all invocations of this command before submitting.
129
130test_pause () {
131 if test "$verbose" = t; then
132 "$SHELL_PATH" <&6 >&3 2>&4
133 else
134 error >&5 "test_pause requires --verbose"
135 fi
136}
137
138# Call test_commit with the arguments "<message> [<file> [<contents>]]"
139#
140# This will commit a file with the given contents and the given commit
141# message. It will also add a tag with <message> as name.
142#
143# Both <file> and <contents> default to <message>.
144
145test_commit () {
9a0231b3 146 notick= &&
5ed75e2a
MV
147 signoff= &&
148 while test $# != 0
149 do
150 case "$1" in
151 --notick)
152 notick=yes
153 ;;
154 --signoff)
155 signoff="$1"
156 ;;
157 *)
158 break
159 ;;
160 esac
9a0231b3 161 shift
5ed75e2a 162 done &&
9a0231b3 163 file=${2:-"$1.t"} &&
12a29b1a
TR
164 echo "${3-$1}" > "$file" &&
165 git add "$file" &&
9a0231b3
JH
166 if test -z "$notick"
167 then
168 test_tick
169 fi &&
5ed75e2a 170 git commit $signoff -m "$1" &&
12a29b1a
TR
171 git tag "$1"
172}
173
174# Call test_merge with the arguments "<message> <commit>", where <commit>
175# can be a tag pointing to the commit-to-merge.
176
177test_merge () {
178 test_tick &&
179 git merge -m "$1" "$2" &&
180 git tag "$1"
181}
182
183# This function helps systems where core.filemode=false is set.
184# Use it instead of plain 'chmod +x' to set or unset the executable bit
185# of a file in the working directory and add it to the index.
186
187test_chmod () {
188 chmod "$@" &&
189 git update-index --add "--chmod=$@"
190}
191
192# Unset a configuration variable, but don't fail if it doesn't exist.
193test_unconfig () {
194 git config --unset-all "$@"
195 config_status=$?
196 case "$config_status" in
197 5) # ok, nothing to unset
198 config_status=0
199 ;;
200 esac
201 return $config_status
202}
203
204# Set git config, automatically unsetting it after the test is over.
205test_config () {
206 test_when_finished "test_unconfig '$1'" &&
207 git config "$@"
208}
209
210test_config_global () {
211 test_when_finished "test_unconfig --global '$1'" &&
212 git config --global "$@"
213}
214
215write_script () {
216 {
217 echo "#!${2-"$SHELL_PATH"}" &&
218 cat
219 } >"$1" &&
220 chmod +x "$1"
221}
222
223# Use test_set_prereq to tell that a particular prerequisite is available.
224# The prerequisite can later be checked for in two ways:
225#
226# - Explicitly using test_have_prereq.
227#
228# - Implicitly by specifying the prerequisite tag in the calls to
229# test_expect_{success,failure,code}.
230#
231# The single parameter is the prerequisite tag (a simple word, in all
232# capital letters by convention).
233
234test_set_prereq () {
f3cfc3b2 235 satisfied_prereq="$satisfied_prereq$1 "
12a29b1a 236}
f3cfc3b2 237satisfied_prereq=" "
04083f27
JH
238lazily_testable_prereq= lazily_tested_prereq=
239
240# Usage: test_lazy_prereq PREREQ 'script'
241test_lazy_prereq () {
242 lazily_testable_prereq="$lazily_testable_prereq$1 "
243 eval test_prereq_lazily_$1=\$2
244}
245
246test_run_lazy_prereq_ () {
247 script='
248mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
249(
250 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
251)'
252 say >&3 "checking prerequisite: $1"
253 say >&3 "$script"
254 test_eval_ "$script"
255 eval_ret=$?
256 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
257 if test "$eval_ret" = 0; then
258 say >&3 "prerequisite $1 ok"
259 else
260 say >&3 "prerequisite $1 not satisfied"
261 fi
262 return $eval_ret
263}
12a29b1a
TR
264
265test_have_prereq () {
266 # prerequisites can be concatenated with ','
267 save_IFS=$IFS
268 IFS=,
269 set -- $*
270 IFS=$save_IFS
271
272 total_prereq=0
273 ok_prereq=0
274 missing_prereq=
275
276 for prerequisite
277 do
04083f27
JH
278 case " $lazily_tested_prereq " in
279 *" $prerequisite "*)
280 ;;
281 *)
282 case " $lazily_testable_prereq " in
283 *" $prerequisite "*)
284 eval "script=\$test_prereq_lazily_$prerequisite" &&
285 if test_run_lazy_prereq_ "$prerequisite" "$script"
286 then
287 test_set_prereq $prerequisite
288 fi
289 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
290 esac
291 ;;
292 esac
293
12a29b1a 294 total_prereq=$(($total_prereq + 1))
f3cfc3b2 295 case "$satisfied_prereq" in
12a29b1a
TR
296 *" $prerequisite "*)
297 ok_prereq=$(($ok_prereq + 1))
298 ;;
299 *)
300 # Keep a list of missing prerequisites
301 if test -z "$missing_prereq"
302 then
303 missing_prereq=$prerequisite
304 else
305 missing_prereq="$prerequisite,$missing_prereq"
306 fi
307 esac
308 done
309
310 test $total_prereq = $ok_prereq
311}
312
313test_declared_prereq () {
314 case ",$test_prereq," in
315 *,$1,*)
316 return 0
317 ;;
318 esac
319 return 1
320}
321
322test_expect_failure () {
323 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
324 test "$#" = 2 ||
325 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
326 export test_prereq
327 if ! test_skip "$@"
328 then
329 say >&3 "checking known breakage: $2"
330 if test_run_ "$2" expecting_failure
331 then
332 test_known_broken_ok_ "$1"
333 else
334 test_known_broken_failure_ "$1"
335 fi
336 fi
337 echo >&3 ""
338}
339
340test_expect_success () {
341 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
342 test "$#" = 2 ||
343 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
344 export test_prereq
345 if ! test_skip "$@"
346 then
347 say >&3 "expecting success: $2"
348 if test_run_ "$2"
349 then
350 test_ok_ "$1"
351 else
352 test_failure_ "$@"
353 fi
354 fi
355 echo >&3 ""
356}
357
358# test_external runs external test scripts that provide continuous
359# test output about their progress, and succeeds/fails on
360# zero/non-zero exit code. It outputs the test output on stdout even
361# in non-verbose mode, and announces the external script with "# run
362# <n>: ..." before running it. When providing relative paths, keep in
363# mind that all scripts run in "trash directory".
364# Usage: test_external description command arguments...
365# Example: test_external 'Perl API' perl ../path/to/test.pl
366test_external () {
367 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
368 test "$#" = 3 ||
369 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
370 descr="$1"
371 shift
372 export test_prereq
373 if ! test_skip "$descr" "$@"
374 then
375 # Announce the script to reduce confusion about the
376 # test output that follows.
377 say_color "" "# run $test_count: $descr ($*)"
378 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
379 # to be able to use them in script
380 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
381 # Run command; redirect its stderr to &4 as in
382 # test_run_, but keep its stdout on our stdout even in
383 # non-verbose mode.
384 "$@" 2>&4
385 if [ "$?" = 0 ]
386 then
387 if test $test_external_has_tap -eq 0; then
388 test_ok_ "$descr"
389 else
390 say_color "" "# test_external test $descr was ok"
391 test_success=$(($test_success + 1))
392 fi
393 else
394 if test $test_external_has_tap -eq 0; then
395 test_failure_ "$descr" "$@"
396 else
397 say_color error "# test_external test $descr failed: $@"
398 test_failure=$(($test_failure + 1))
399 fi
400 fi
401 fi
402}
403
404# Like test_external, but in addition tests that the command generated
405# no output on stderr.
406test_external_without_stderr () {
407 # The temporary file has no (and must have no) security
408 # implications.
409 tmp=${TMPDIR:-/tmp}
410 stderr="$tmp/git-external-stderr.$$.tmp"
411 test_external "$@" 4> "$stderr"
412 [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
413 descr="no stderr: $1"
414 shift
415 say >&3 "# expecting no stderr from previous command"
416 if [ ! -s "$stderr" ]; then
417 rm "$stderr"
418
419 if test $test_external_has_tap -eq 0; then
420 test_ok_ "$descr"
421 else
422 say_color "" "# test_external_without_stderr test $descr was ok"
423 test_success=$(($test_success + 1))
424 fi
425 else
426 if [ "$verbose" = t ]; then
427 output=`echo; echo "# Stderr is:"; cat "$stderr"`
428 else
429 output=
430 fi
431 # rm first in case test_failure exits.
432 rm "$stderr"
433 if test $test_external_has_tap -eq 0; then
434 test_failure_ "$descr" "$@" "$output"
435 else
436 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
437 test_failure=$(($test_failure + 1))
438 fi
439 fi
440}
441
442# debugging-friendly alternatives to "test [-f|-d|-e]"
443# The commands test the existence or non-existence of $1. $2 can be
444# given to provide a more precise diagnosis.
445test_path_is_file () {
446 if ! [ -f "$1" ]
447 then
448 echo "File $1 doesn't exist. $*"
449 false
450 fi
451}
452
453test_path_is_dir () {
454 if ! [ -d "$1" ]
455 then
456 echo "Directory $1 doesn't exist. $*"
457 false
458 fi
459}
460
461test_path_is_missing () {
462 if [ -e "$1" ]
463 then
464 echo "Path exists:"
465 ls -ld "$1"
466 if [ $# -ge 1 ]; then
467 echo "$*"
468 fi
469 false
470 fi
471}
472
473# test_line_count checks that a file has the number of lines it
474# ought to. For example:
475#
476# test_expect_success 'produce exactly one line of output' '
477# do something >output &&
478# test_line_count = 1 output
479# '
480#
481# is like "test $(wc -l <output) = 1" except that it passes the
482# output through when the number of lines is wrong.
483
484test_line_count () {
485 if test $# != 3
486 then
487 error "bug in the test script: not 3 parameters to test_line_count"
488 elif ! test $(wc -l <"$3") "$1" "$2"
489 then
490 echo "test_line_count: line count for $3 !$1 $2"
491 cat "$3"
492 return 1
493 fi
494}
495
496# This is not among top-level (test_expect_success | test_expect_failure)
497# but is a prefix that can be used in the test script, like:
498#
499# test_expect_success 'complain and die' '
500# do something &&
501# do something else &&
502# test_must_fail git checkout ../outerspace
503# '
504#
505# Writing this as "! git checkout ../outerspace" is wrong, because
506# the failure could be due to a segv. We want a controlled failure.
507
508test_must_fail () {
509 "$@"
510 exit_code=$?
511 if test $exit_code = 0; then
512 echo >&2 "test_must_fail: command succeeded: $*"
513 return 1
514 elif test $exit_code -gt 129 -a $exit_code -le 192; then
515 echo >&2 "test_must_fail: died by signal: $*"
516 return 1
517 elif test $exit_code = 127; then
518 echo >&2 "test_must_fail: command not found: $*"
519 return 1
520 fi
521 return 0
522}
523
524# Similar to test_must_fail, but tolerates success, too. This is
525# meant to be used in contexts like:
526#
527# test_expect_success 'some command works without configuration' '
528# test_might_fail git config --unset all.configuration &&
529# do something
530# '
531#
532# Writing "git config --unset all.configuration || :" would be wrong,
533# because we want to notice if it fails due to segv.
534
535test_might_fail () {
536 "$@"
537 exit_code=$?
538 if test $exit_code -gt 129 -a $exit_code -le 192; then
539 echo >&2 "test_might_fail: died by signal: $*"
540 return 1
541 elif test $exit_code = 127; then
542 echo >&2 "test_might_fail: command not found: $*"
543 return 1
544 fi
545 return 0
546}
547
548# Similar to test_must_fail and test_might_fail, but check that a
549# given command exited with a given exit code. Meant to be used as:
550#
551# test_expect_success 'Merge with d/f conflicts' '
552# test_expect_code 1 git merge "merge msg" B master
553# '
554
555test_expect_code () {
556 want_code=$1
557 shift
558 "$@"
559 exit_code=$?
560 if test $exit_code = $want_code
561 then
562 return 0
563 fi
564
565 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
566 return 1
567}
568
569# test_cmp is a helper function to compare actual and expected output.
570# You can use it like:
571#
572# test_expect_success 'foo works' '
573# echo expected >expected &&
574# foo >actual &&
575# test_cmp expected actual
576# '
577#
578# This could be written as either "cmp" or "diff -u", but:
579# - cmp's output is not nearly as easy to read as diff -u
580# - not all diff versions understand "-u"
581
582test_cmp() {
583 $GIT_TEST_CMP "$@"
584}
585
d17cf5f3
MK
586# Print a sequence of numbers or letters in increasing order. This is
587# similar to GNU seq(1), but the latter might not be available
588# everywhere (and does not do letters). It may be used like:
589#
590# for i in `test_seq 100`; do
591# for j in `test_seq 10 20`; do
592# for k in `test_seq a z`; do
593# echo $i-$j-$k
594# done
595# done
596# done
597
598test_seq () {
599 case $# in
600 1) set 1 "$@" ;;
601 2) ;;
602 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
603 esac
604 "$PERL_PATH" -le 'print for $ARGV[0]..$ARGV[1]' -- "$@"
605}
606
12a29b1a
TR
607# This function can be used to schedule some commands to be run
608# unconditionally at the end of the test to restore sanity:
609#
610# test_expect_success 'test core.capslock' '
611# git config core.capslock true &&
612# test_when_finished "git config --unset core.capslock" &&
613# hello world
614# '
615#
616# That would be roughly equivalent to
617#
618# test_expect_success 'test core.capslock' '
619# git config core.capslock true &&
620# hello world
621# git config --unset core.capslock
622# '
623#
624# except that the greeting and config --unset must both succeed for
625# the test to pass.
626#
627# Note that under --immediate mode, no clean-up is done to help diagnose
628# what went wrong.
629
630test_when_finished () {
631 test_cleanup="{ $*
632 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
633}
634
635# Most tests can use the created repository, but some may need to create more.
636# Usage: test_create_repo <directory>
637test_create_repo () {
638 test "$#" = 1 ||
639 error "bug in the test script: not 1 parameter to test-create-repo"
640 repo="$1"
641 mkdir -p "$repo"
642 (
643 cd "$repo" || error "Cannot setup test environment"
644 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
645 error "cannot run git init -- have you built things yet?"
646 mv .git/hooks .git/hooks-disabled
647 ) || exit
648}